import { BaseStopableAnnotator } from "./BaseStopableAnnotator";
import InternalConfig from "../utils/InternalConfig";
import { AnnotatorContainer } from "../AnnotatorContainer";
import { StrokeType } from "../model/Styles";
export declare class FreeDrawAnnotator extends BaseStopableAnnotator {
    static readonly xtype: string;
    private bufferSize;
    private rect;
    private strPath;
    private buffer;
    private points;
    private svgContainer;
    private initialized;
    private isDrawing;
    constructor(config: InternalConfig, parent: AnnotatorContainer);
    private createPath;
    private initAnnotator;
    stop(): void;
    private parentTouchMove;
    private parentMouseMove;
    private parentTouchStart;
    private parentMouseDown;
    private startDraging;
    private parentTouchEnd;
    private parentMouseUp;
    private endDragging;
    private getMousePosition;
    private appendToBuffer;
    private getAveragePoint;
    private updateSvgPath;
    moveBy(dx: number, dy: number, evt: MouseEvent): void;
    setSelected(selected: boolean): void;
    intersects(x: number, y: number, w: number, h: number): boolean;
    setStrokeType(strokeType: StrokeType): void;
    setStrokeWidth(width: number): void;
    setDrawColor(color: string): void;
    toXML(): Element;
    fromXML(element: Element): void;
    toJSON(): Object;
    fromJSON(obj: any): void;
}
